﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub Process_Globals
	Private nid As Int = 1
	Private GPS As GPS
	Private Tracking As Boolean
	Private LastUpdateTime As Long
	Private lock As PhoneWakeState
	Private tmr As Timer
End Sub

Sub Service_Create
	LogColor("TRACKER - Service_Create " & DateTime.Time(DateTime.Now), Colors.Red)
	tmr.Initialize("tmr", 10000)
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	GPS.Initialize("gps")
	lock.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	LogColor("TRACKER - Service_Start " & DateTime.Time(DateTime.Now), Colors.Red)
'	Service.StartForeground(nid, CreateNotification("..."))

	' Doing as below, you can avoid the first and "sticked"
	' notification but, I don't know why, the service is killed often
	' and when it restarts it is killed again immediately.
	Service.StartForeground(0, Null)

	StartServiceAt(Me, DateTime.Now + 5 * DateTime.TicksPerMinute, True)
	Track
	tmr.Enabled = True
End Sub

Public Sub Track
	LogColor("TRACKER - Track " & DateTime.Time(DateTime.Now), Colors.Blue)
	If Tracking Then Return
	If Starter.rp.Check(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION) = False Then
		Log("No permission")
		Return
	End If
	GPS.Start(0, 0)
	Tracking = True
End Sub

Sub GPS_LocationChanged (Location1 As Location)
	LogColor("TRACKER - GPS_LocationChanged " & DateTime.Time(DateTime.Now), Colors.Blue)
	If DateTime.Now > LastUpdateTime + 10 * DateTime.TicksPerSecond Then
		Dim n As Notification = CreateNotification($"$2.5{Location1.Latitude} / $2.5{Location1.Longitude}"$)
		n.Notify(nid)
		LastUpdateTime = DateTime.Now
	End If
End Sub

Sub CreateNotification (Body As String) As Notification
	LogColor("TRACKER - CreateNotification " & DateTime.Time(DateTime.Now), Colors.Blue)
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Light = True
	notification.Icon = "icon"
	notification.SetInfo("Tracking location", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	LogColor("TRACKER - Service_Destroy " & DateTime.Time(DateTime.Now), Colors.Red)
	tmr.Enabled = False
	If Tracking Then
		GPS.Stop
	End If
	Tracking = False
	lock.ReleasePartialLock
End Sub

Sub tmr_Tick
	Dim n As Notification = CreateNotification("notifica timer")
	n.Notify(nid)
	LastUpdateTime = DateTime.Now
End Sub